;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.pl

include "attractor.l

;początkowe wartości współczynników:
"init := {-1.164 1.41 -1.42 -1.6}
;wartości dla f i g klasy bazowej:
;"init := {1.7 1.7 0.6 1.2}
;"init := {-1.9 -2.8 -1.1 0.3} setbg "black
;"init := {1.5 -1.8 1.6 0.9}
;"init := {-1.7 1.3 -0.1 -1.2}
;"init := {-1.7 1.8 -1.9 -0.4}
;"init := {-1.8 -2.0 -0.5 -0.9}

"p := newarray 4
:p,1 := (slider "t1 {8 45 164} {-3 3} :init,1)
:p,2 := (slider "t2 {8 90 164} {-3 3} :init,2)
:p,3 := (slider "t3 {8 135 164} {-3 3} :init,3)
:p,4 := (slider "t4 {8 180 164} {-3 3} :init,4)

to custom_attractor
  use attractor

  ;nadpisz funkcje f i g aby zmienić rodzaj atraktora
  ;lub zakomentuj ich definicje by użyć wzorów z klasy
  ;bazowej
  to f
    op (radsin :t,1 * :xy,2) - (radcos :t,2 * :xy,1)
  end
  to g
    op (radsin :t,3 * :xy,1) - (radcos :t,4 * :xy,2)
  end

  to modify_at :pt ;przesłonięta funkcja koloru
    let "c pointat :pt
    if runif 1 > (0.01 * :c,4)^(1/4) [
      (setpointat :pt color 10 * :c,4 :c,4 + 0.4)
    ]
  end

  setpalette "hot
end

"a := (newt $custom_attractor)

"bhold := (button "Rysuj {8 8 80 24} [
  "hold := not :hold
  ifelse :hold [settext :bhold "Rysuj]
  [go @ :a settext :bhold "Wstrzymaj]
])

"bclean := (button "Wyczyść {92 8 80 24} [clean])

"brnd := (button "Losuj {176 8 80 24} [
  foreach "sl :p [
    setvalue :sl 0.001 * int (runif -1900 1900)
  ]
])

